﻿Imports System.IO
Imports System.Net   'Web
Imports System.Diagnostics.Process
Imports Microsoft.VisualBasic.FileIO
Imports System.Net.Sockets
Module Module1
    'new list
    ' Public Holding_array() As Integer = {&H1234, &H5678, &H9876, 1011, 65, 86, 82, 67, 64, 0, 0}
    Public Holding_array(100) As Integer
    Public string_buffer_0 As String = ""
    Public string_buffer_1 As String = ""
    Public string_buffer_2 As String = ""
    Public raw_buffer(32) As Byte
    Public raw_buffer_lenght As Integer
    Public rx_buffer(255) As Byte
    Public rx_buffer_pointer As Integer
    Public decode_buffer(32) As Byte
    Public rx_buffer_size As Integer = 255
    Public holding_registers(20) As Integer
    Public tx_buffer(261) As Byte 'id + function code + bytes to send + crc = 5 byte + FF words = 261 bytes max 
    Public tx_buffer_size As Integer

    'settings_matrix
    Public Const com_port = 0, baud_rate = 1, data_bits = 2, parity = 3, stop_bits = 4, slave_no = 5, holding_header = 6, holding_num = 7
    Public settings(10) As String

    Public message_address As Integer
    Public message_number As Integer
    Public comms_timer As Integer
    Public holding_reg_start As Integer
    Public refresh_display As Boolean

    Public slave_number As Byte = 10
    Public holding_header_address As Integer = 0
    Public holding_number As Integer = 1



    Public Function build_message(slave_id As Byte, function_code As Byte, address As Integer, number_or_value_of_register As Integer)
        'build up message to send back to master
        Dim buffer(261) As Byte
        Dim message_crc As Integer
        Dim message_pointer As Integer

        'build function 3 message
        If function_code = &H3 Then
            'assemble message
            buffer(0) = slave_id
            buffer(1) = function_code
            buffer(2) = 2 * CByte(number_or_value_of_register)

            'build message content
            message_pointer = 0
            Do Until message_pointer = number_or_value_of_register
                buffer((message_pointer * 2) + 3) = get_hi_byte_of_int(Holding_array(message_pointer + address))
                buffer((message_pointer * 2) + 4) = get_lo_byte_of_int(Holding_array(message_pointer + address))
                message_pointer = message_pointer + 1
            Loop
            'generate crc of packet
            '(slave id = 0) + (function = 1) + (no of reg = 2) + (no of reg * 2) = message to be crc checked
            message_crc = crc16(buffer, 0, 2 + (2 * CByte(number_or_value_of_register)))
            message_pointer = message_pointer + 1
            'tag on message crc
            buffer((message_pointer * 2) + 1) = get_hi_byte_of_int(message_crc)
            buffer((message_pointer * 2) + 2) = get_lo_byte_of_int(message_crc)
        End If

        'build function 6 message
        If function_code = &H6 Then
            'assemble message
            buffer(0) = slave_id
            buffer(1) = function_code
            buffer(2) = get_hi_byte_of_int(address)
            buffer(3) = get_lo_byte_of_int(address)
            buffer(4) = get_hi_byte_of_int(number_or_value_of_register)
            buffer(5) = get_lo_byte_of_int(number_or_value_of_register)

            'generate crc of packet
            '(slave id = 0) + (function = 1) + (address = 2) + (data = 2) = message to be crc checked
            message_crc = crc16(buffer, 0, 5)
            'tag on message crc
            buffer(6) = get_hi_byte_of_int(message_crc)
            buffer(7) = get_lo_byte_of_int(message_crc)
        End If



        'passback
        build_message = buffer
    End Function
    Public Function build_exception(slave_id As Byte, function_code As Byte, exception_code As Byte)
        'The Slave Address (0A hex = address10 )
        'Function Code 1 (read Coil Status - with the highest bit set)
        'The Exception Code
        'The CRC(cyclic redundancy check).
        'build up message to send back to master

        Dim buffer(261) As Byte
        Dim message_crc As Integer

        'build message
        buffer(0) = slave_id
        buffer(1) = function_code
        buffer(2) = exception_code

        'generate crc of packet
        message_crc = crc16(buffer, 0, 2)
        buffer(3) = get_hi_byte_of_int(message_crc)
        buffer(4) = get_lo_byte_of_int(message_crc)
        'passback
        build_exception = buffer

    End Function

    Public Function message_size(number_of_registers As Integer)
        message_size = 5 + 2 * CByte(number_of_registers)
    End Function

    Public Function get_hi_byte_of_int(input As Integer) As Byte
        get_hi_byte_of_int = CByte((input And &HFF00) / 256)
    End Function
    Public Function get_lo_byte_of_int(input As Integer) As Byte
        get_lo_byte_of_int = CByte(input And &HFF)
    End Function

    Function crc_check(packet() As Byte, packet_lenght As Integer) As Boolean
        'this function checks if a packet is valid by looking through the packet for a
        'group with a correct crc if a match is found the function returns an index greater 
        'than zero if no match if found then a index of zero is returned.
        Dim rxd_crc As Integer
        Dim cal_crc As Integer
        'packet remove packet byts 7 and 8 inorder to generate a crc for checking
        rxd_crc = (packet(6) * 256) + packet(7)
        cal_crc = crc16(packet, 0, 5)
        If rxd_crc = cal_crc Then
            crc_check = 1
        Else
            crc_check = 0
        End If
    End Function

    Function get_packet(packet() As Byte, packet_start As Integer, packet_lenght As Integer) As Byte()
        'extract packet from rx buffer so that it can be checked
        Dim x_pointer As Integer
        Dim buffer(255) As Byte

        x_pointer = 0
        For x = 0 To packet_lenght
            buffer(x) = packet(packet_start + x_pointer)
            If (packet_start + x_pointer) >= rx_buffer_size Then
                x_pointer = 0
                packet_start = 0
            Else
                x_pointer = x_pointer + 1
            End If
        Next
        'trasfer the buffer
        get_packet = buffer
    End Function

    Public Sub kill_packet(start As Integer, number As Integer)
        'remove packet from buffer once it has been used
        Dim x_index As Integer

        x_index = 0
        For x = 0 To number
            rx_buffer(start + x_index) = 0
            If start + x_index >= rx_buffer_size Then
                x_index = 0
                start = 0
            Else
                x_index = x_index + 1
            End If
        Next x
    End Sub

    Function get_message_address(packet() As Byte, packet_start As Integer) As Integer
        'get header address from packet if crc is ok
        get_message_address = (packet(packet_start + 2) * 256) + packet(packet_start + 3)
    End Function
    Function get_number_or_value_of_register_s(packet() As Byte, packet_start As Integer) As Integer
        'get header address from packet if crc is ok
        get_number_or_value_of_register_s = (packet(packet_start + 4) * 256) + packet(packet_start + 5)
    End Function
    Function crc16(packet() As Byte, packet_start As Integer, packet_lenght As Integer) As Integer
        'this function generates a crc check for a packet
        'declare variables
        Dim xor_loops As Byte
        Dim message_byte As UInt16
        Dim crc As UInt16 = &HFFFF
        Dim poly As UInt16 = &HA001
        Dim rotate_carry As Boolean
        Dim mbyte As Byte
        Dim upper_crc As UInt16
        Dim lower_crc As UInt16

        'loop through message
        For mbyte = 0 To packet_lenght
            'get message byte 
            message_byte = Convert.ToInt32(packet(packet_start + mbyte))

            'xor crc with message byte
            crc = crc Xor message_byte
            'xor 8 times
            For xor_loops = 1 To 8
                'check for carry
                If crc And 1 Then rotate_carry = True Else rotate_carry = False
                If rotate_carry = True Then crc = crc - 1
                crc = crc / 2
                'xor with poly if carry
                If rotate_carry = True Then crc = crc Xor poly
            Next xor_loops
        Next mbyte

        'byte swap
        upper_crc = (crc And &HFF00) / 256
        lower_crc = crc And &HFF
        'return crc
        crc16 = lower_crc * 256 + upper_crc

    End Function

    Public Sub print_buffer_0(serial_buffer() As Byte, size As Integer)

        'show the buffer as a string
        string_buffer_0 = ""
        'transfer the buffer into a string
        For x = 0 To size
            If serial_buffer(x) <= 9 Then
                string_buffer_0 = string_buffer_0 & "0" & Hex(serial_buffer(x))
            Else
                string_buffer_0 = string_buffer_0 & Hex(serial_buffer(x))
            End If
        Next x

    End Sub
    Public Sub print_buffer_1(serial_buffer() As Byte, size As Integer)

        'show the buffer as a string
        string_buffer_1 = ""
        'transfer the buffer into a string
        For x = 0 To size
            If serial_buffer(x) <= 9 Then
                string_buffer_1 = string_buffer_1 & "0" & Hex(serial_buffer(x))
            Else
                string_buffer_1 = string_buffer_1 & Hex(serial_buffer(x))
            End If
        Next x

    End Sub
    Public Sub print_buffer_2(serial_buffer() As Byte, size As Integer)

        'show the buffer as a string
        string_buffer_2 = ""
        'transfer the buffer into a string
        For x = 0 To size
            If serial_buffer(x) <= 9 Then
                string_buffer_2 = string_buffer_2 & "0" & Hex(serial_buffer(x))
            Else
                string_buffer_2 = string_buffer_2 & Hex(serial_buffer(x))
            End If
        Next x

    End Sub

    Public Sub read_settings_file()

        'forbidden path
        Dim file_path As String
        file_path = CurDir() & "\settings.dat"

        On Error GoTo FILERR

        ' Open file.txt with the Using statement.
        Using file As StreamReader = New StreamReader(file_path)
            ' Store contents in this String.
            Dim line As String

            ' Read first line.
            'line = r.ReadLine
            line = file.ReadLine
            ' Loop over each line in file, While list is Not Nothing.
            Do While (Not line Is Nothing)
                'read_settings_file
                'com_port = 0, baud_rate = 1, data_bits = 2, parity = 3, stop_bits = 4, slave_no = 5, holding_header = 6, holding_num = 7

                Dim columns() As String = line.Split(","c)
                settings(com_port) = columns(0)
                settings(baud_rate) = columns(1)
                settings(data_bits) = columns(2)
                settings(parity) = columns(3)
                settings(stop_bits) = columns(4)
                settings(slave_no) = columns(5)
                settings(holding_header) = columns(6)
                settings(holding_num) = columns(7)
                'read next line
                line = file.ReadLine


            Loop
        End Using

        GoTo FILEOK
FILERR:
        'load_default_settings()
        MsgBox("error reading settings.dat")
FILEOK:
    End Sub

    Public Sub write_settings_file()

        Dim output_line As String
        Dim Writefile As System.IO.StreamWriter

        'read_settings_file
        'com_port = 0, baud_rate = 1, data_bits = 2, parity = 3, stop_bits = 4, slave_no = 5, holding_header = 6, holding_num = 7

        'overrite change the end bool to a false /  true for append
        Writefile = My.Computer.FileSystem.OpenTextFileWriter(CurDir() & "\settings.dat", False)

        output_line = ""
        output_line = settings(com_port) & "," & settings(baud_rate) & "," & settings(data_bits) & "," & settings(parity) & "," & settings(stop_bits) & "," & settings(slave_no) & "," & settings(holding_header) & "," & settings(holding_num) & vbCrLf
        Writefile.Write(output_line)


        'close and free up memory
        Writefile.Close()
        Writefile.Dispose()
        'MsgBox("Settings saved ok...")


    End Sub


End Module
