﻿Public Class Form1
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'David K Smith
        'Project No: 20200127 
        'V0.94
        ' - function code 3 reads Of upto 100 holding registers
        ' - Illegal data address of function 3 requests
        'V0.95
        ' - tidy up comms settings menu
        'V0.96
        ' - tidy up form names
        ' - function code 6 single holding register writes
        ' - Illegal data address of function 6 writes
        'V0.97
        ' - fix missalighnment of holding array and display array

        'preload settings incase file load fails
        settings(com_port) = "COM1"
        settings(baud_rate) = 9600
        settings(data_bits) = 8
        settings(parity) = "NONE"
        settings(stop_bits) = 1
        settings(slave_no) = "10"
        settings(holding_header) = "0"
        settings(holding_num) = "1"

        'reading files
        Try
            'read the program settings
            read_settings_file()
        Catch ex As Exception
            MsgBox("somthing went wrong with the file load check settings")
        End Try

        'load comms params
        slave_number = settings(slave_no)
        lbl_slave_number.Text = slave_number
        holding_header_address = settings(holding_header)
        lbl_holding_header_address.Text = holding_header_address + 40001
        holding_number = settings(holding_num)
        lbl_holding_header_number.Text = settings(holding_num)

        'setup list
        ListBox1.SelectionMode = SelectionMode.MultiSimple
        update_list()

    End Sub


    Public Sub update_list()
        'clean list
        ListBox1.Items.Clear()
        'update list
        For x = 0 To holding_number - 1
            ListBox1.Items.Add((holding_header_address + 40001 + x) & " = " & "D:" & Holding_array(x) & ",H:" & Hex(Holding_array(x)))
        Next x

    End Sub

    Private Sub SerialPort1_DataReceived(ByVal sender As System.Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived

        Dim packet_start_index As Integer
        Dim raw_pointer As Integer = 0
        Dim next_x As Integer
        Dim function_3_packet_suspected As Boolean
        Dim function_6_packet_suspected As Boolean
        Dim function_code_3_detected As Boolean
        Dim function_code_6_detected As Boolean

        Try

            '--------------------------------raw buffer handeler--------------------------------

            'load the rx serial data into a raw regitser
            raw_buffer_lenght = SerialPort1.BytesToRead
            SerialPort1.Read(raw_buffer, 0, raw_buffer_lenght)

            'copy new chariters out of the raw buffer
            Do Until raw_pointer = raw_buffer_lenght
                'move the raw buffer to the rx_buffer
                rx_buffer(rx_buffer_pointer) = raw_buffer(raw_pointer)
                'increment the raw pointer
                raw_pointer = raw_pointer + 1
                'increment the rx_buffer Pointer
                If rx_buffer_pointer >= rx_buffer_size Then
                    rx_buffer_pointer = 0
                Else
                    rx_buffer_pointer = rx_buffer_pointer + 1
                End If
            Loop

            'print_buffer
            print_buffer_0(rx_buffer, 255)

            '--------------------------------rx buffer handeler--------------------------------
            'detect the start of a valid packet
            'set the packet_start_index as invalid
            packet_start_index = 256
            For x = 0 To rx_buffer_size
                'clear pre decoding detectors
                function_3_packet_suspected = False
                function_6_packet_suspected = False
                'check for correct slave and function
                If x < rx_buffer_size Then
                    'befor the last entry
                    next_x = x + 1
                Else
                    'on the last entry
                    next_x = 0
                End If

                'look for slave address and function code 3 detection
                If rx_buffer(x) = slave_number And rx_buffer(next_x) = &H3 Then
                    'set detection flag
                    function_3_packet_suspected = True
                    function_6_packet_suspected = False
                    'if the start of a packet is found move into the decoding buffer
                    decode_buffer = get_packet(rx_buffer, x, 7)
                End If

                'look for slave address and function code 6 detection
                If rx_buffer(x) = slave_number And rx_buffer(next_x) = &H6 Then
                    'set detection flag
                    function_3_packet_suspected = False
                    function_6_packet_suspected = True
                    'if the start of a packet is found move into the decoding buffer
                    decode_buffer = get_packet(rx_buffer, x, 7)
                End If

                'funtction code 3 packet decoding
                'if the start of a funcion code 3 packet has been found and moved into the decoder buffer
                'and the the packet start index is not an invalid index then check and decode packet
                If function_3_packet_suspected And packet_start_index = 256 Then
                    'then crc check packet
                    If crc_check(decode_buffer, 7) Then
                        'note valid packet start index
                        packet_start_index = x
                        'remove packet with good crc from rx_buffer
                        kill_packet(packet_start_index, 7)
                        'extract data from valid decode_buffer
                        message_address = get_message_address(decode_buffer, 0)
                        message_number = get_number_or_value_of_register_s(decode_buffer, 0)
                        'note packet detected
                        function_3_packet_suspected = False
                        function_code_3_detected = True
                    End If
                End If

                'funtction code 6 packet decoding
                'if the start of a funcion code 6 packet has been found and moved into the decoder buffer
                'and the the packet start index is not an invalid index then check and decode packet
                If function_6_packet_suspected And packet_start_index = 256 Then
                    'then crc check packet
                    If crc_check(decode_buffer, 7) Then
                        'note valid packet start index
                        packet_start_index = x
                        'remove packet with good crc from rx_buffer
                        kill_packet(packet_start_index, 7)
                        'extract data from valid decode_buffer
                        message_address = get_message_address(decode_buffer, 0)
                        message_number = get_number_or_value_of_register_s(decode_buffer, 0)
                        'note packet detected
                        function_6_packet_suspected = False
                        function_code_6_detected = True
                    End If
                End If

            Next

            '--------------------------------action decoded messages--------------------------------
            'function code 3 packet processing
            'if packet contained correct slave address, was inside the holding register range
            'and had a valid crc then process.
            If function_code_3_detected And packet_start_index <> 256 Then
                'print the rx buffer
                print_buffer_1(decode_buffer, 10)
                'clear decode_buffer
                Array.Clear(decode_buffer, 0, 10)
                'check if message is out of bounds
                If message_address < holding_header_address Or (message_address + message_number) > (holding_header_address + holding_number) Then
                    tx_buffer = build_exception(slave_number, &H3, &H2)
                    'print the rx buffer
                    print_buffer_2(tx_buffer, 261)
                    'send reply
                    send_packet(tx_buffer, 4)
                    'Console.WriteLine("out of bounds")
                Else
                    'clear comms timer
                    comms_timer = 0
                    'this line adjusts the starting point of the holding array lookup
                    'so that if the holding array starts from an offset point
                    holding_reg_start = message_address - holding_header_address
                    'build reply message
                    tx_buffer = build_message(slave_number, &H3, holding_reg_start, message_number)
                    tx_buffer_size = message_size(message_number)
                    'print the rx buffer
                    print_buffer_2(tx_buffer, 261)
                    'send reply
                    send_packet(tx_buffer, tx_buffer_size)
                    'Console.WriteLine("not out of bounds")
                End If
                'clear doen packet detect
                function_code_3_detected = False
            End If

            'function code 6 packet processing
            'if packet contained correct slave address, was inside the holding register range
            'and had a valid crc then process.
            If function_code_6_detected And packet_start_index <> 256 Then
                'print the rx buffer
                print_buffer_1(decode_buffer, 10)
                'clear decode_buffer
                Array.Clear(decode_buffer, 0, 10)
                'check if message is out of bounds
                If message_address < holding_header_address Or message_address >= (holding_header_address + holding_number) Then
                    tx_buffer = build_exception(slave_number, &H6, &H2)
                    'print the rx buffer
                    print_buffer_2(tx_buffer, 261)
                    'send reply
                    send_packet(tx_buffer, 4)
                    'Console.WriteLine("function 6 - out of bounds")
                Else
                    'clear comms timer
                    comms_timer = 0
                    'this line adjusts the starting point of the holding array lookup
                    'so that if the holding array starts from an offset point
                    holding_reg_start = message_address - holding_header_address
                    'write data into holding array
                    Holding_array(message_address - holding_header_address) = message_number
                    'build reply message
                    tx_buffer = build_message(slave_number, &H6, message_address, message_number)
                    'print the rx buffer
                    print_buffer_2(tx_buffer, 261)
                    'send reply
                    send_packet(tx_buffer, 7)
                    'Console.WriteLine("function 6 - not out of bounds")
                    'request display update
                    refresh_display = True
                End If
                'clear doen packet detect
                function_code_6_detected = False
            End If

        Catch ex As Exception
        End Try
        '
    End Sub

    Private Sub send_packet(tx_message() As Byte, packet_size As Integer)
        Dim txbyte() As Byte
        'send packet
        For x = 0 To packet_size
            txbyte = BitConverter.GetBytes(tx_message(x))
            SerialPort1.Write(txbyte, 0, 1)
        Next
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        'update the packet screen when enabled
        If frm_buffer_view.Visible Then
            frm_buffer_view.txt_rx.Text = string_buffer_0
            frm_buffer_view.txt_tx.Text = string_buffer_1
            frm_buffer_view.txt_raw_list.Text = string_buffer_2
        End If
        'simple comms message
        If SerialPort1.IsOpen Then
            If comms_timer < 100 Then
                comms_timer = comms_timer + 1
                lbl_comms_message.Text = "comms ok"
                lbl_comms_message.BackColor = Color.Green
            Else
                lbl_comms_message.Text = "comms timeout"
                lbl_comms_message.BackColor = Color.Red
            End If
        Else
            lbl_comms_message.Text = "port closed"
            lbl_comms_message.BackColor = Color.Gray

        End If
        'update display when requested
        If refresh_display = True Then
            'update display
            update_list()
            refresh_display = False
        End If

    End Sub

    Private Sub ViewCommsToolStripMenuItem2_Click(sender As Object, e As EventArgs) Handles ViewCommsToolStripMenuItem2.Click
        'show comms window
        frm_buffer_view.Visible = True
    End Sub

    Private Sub btn_open_port_Click(sender As Object, e As EventArgs) Handles btn_open_port.Click

        'open the port
        'If Combo_Ports.SelectedIndex = -1 Then
        If settings(com_port) = "" Then
            MessageBox.Show("Please select a port")
            Exit Sub
        Else
            'check port is not open
            If SerialPort1.IsOpen Then
                MessageBox.Show("The port is already open")
                Exit Sub

            Else
                'open the port
                Try
                    'port
                    'SerialPort1.PortName = Combo_Ports.SelectedItem.ToString
                    SerialPort1.PortName = settings(com_port)
                    'baud rate
                    'SerialPort1.BaudRate = Combo_Baud_Rate.SelectedItem
                    SerialPort1.BaudRate = settings(baud_rate)
                    'data bits
                    'SerialPort1.DataBits = Combo_Data_Bits.SelectedItem
                    SerialPort1.DataBits = settings(data_bits)
                    'parity
                    If settings(parity) = "NONE" Then SerialPort1.Parity = System.IO.Ports.Parity.None
                    If settings(parity) = "ODD" Then SerialPort1.Parity = System.IO.Ports.Parity.Odd
                    If settings(parity) = "EVEN" Then SerialPort1.Parity = System.IO.Ports.Parity.Even
                    'stop bits
                    If settings(stop_bits) = "1" Then SerialPort1.StopBits = IO.Ports.StopBits.One
                    If settings(stop_bits) = "2" Then SerialPort1.StopBits = IO.Ports.StopBits.Two
                    SerialPort1.DiscardNull = False
                    SerialPort1.Open()
                Catch ex As Exception
                End Try
            End If
        End If



    End Sub

    Private Sub btn_close_port_Click_1(sender As Object, e As EventArgs) Handles btn_close_port.Click

        If SerialPort1.IsOpen Then
            SerialPort1.Close()
        End If

    End Sub

    Private Sub btn_random_fill_Click(sender As Object, e As EventArgs) Handles btn_random_fill.Click
        For x = 0 To 100
            Holding_array(x) = Rnd() * 1000
        Next
        update_list()
    End Sub

    Private Sub lbl_slave_number_Click(sender As Object, e As EventArgs) Handles lbl_slave_number.Click
        Dim new_number As Integer
        'get input from user
        new_number = Val(InputBox("New Slave ID"))

        'check input 
        If new_number >= 1 And new_number <= 255 Then
            'if ok change
            lbl_slave_number.Text = new_number
            slave_number = new_number
        Else
            'message back
            MsgBox("Valid Slave Addresses are 1 to 255")

        End If
    End Sub

    Private Sub lbl_holding_header_address_Click(sender As Object, e As EventArgs) Handles lbl_holding_header_address.Click
        Dim new_address As Integer
        'get input from user
        new_address = Val(InputBox("New Header Address")) - 40001

        'check input 
        If new_address >= 0 And new_address <= 9998 Then
            'if ok change
            lbl_holding_header_address.Text = new_address + 40001
            holding_header_address = new_address
            'update the list
            update_list()
        Else
            'message back
            MsgBox("Valid Address Ranges is 40001 to 49999")
        End If
    End Sub



    Private Sub lbl_holding_header_number_Click(sender As Object, e As EventArgs) Handles lbl_holding_header_number.Click
        Dim new_number As Integer
        'get input from user
        new_number = Val(InputBox("New No of Holding Registers"))

        'check input 
        If new_number >= 1 And new_number <= 100 Then
            'if ok change
            lbl_holding_header_number.Text = new_number
            holding_number = new_number
            'update the list
            update_list()
        Else
            'message back
            MsgBox("Valid Holding Register Numbers are 1 to 100")

        End If
    End Sub

    Private Sub btn_save_Click(sender As Object, e As EventArgs) Handles btn_save.Click
        'save setting to settings array
        settings(slave_no) = slave_number
        settings(holding_header) = holding_header_address
        settings(holding_num) = holding_number
        'save to disk
        write_settings_file()
        MsgBox("Settings Saved")
    End Sub

    Private Sub ListBox1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ListBox1.SelectedIndexChanged
        Dim new_string As String
        Dim new_number As Integer
        'Next
        If ListBox1.SelectedIndex > -1 Then
            'read user responce
            new_string = InputBox("New Holding Registers HEX Value", "enter", Hex(Holding_array(ListBox1.SelectedIndex)))
            'catch problem with the entered value
            Try
                If new_string <> "" Then new_number = Convert.ToInt32(new_string, 16)
                If new_number >= 0 And new_number <= 65535 Then
                    'write back new value
                    Holding_array(ListBox1.SelectedIndex) = new_number
                    'update the list
                    update_list()
                End If
            Catch ex As Exception
                MsgBox("somthing was wrong with the entered number - please try again")
            End Try

        End If
        'MsgBox(ListBox1.SelectedIndex)
        ListBox1.SelectedIndex = -1
    End Sub

    Private Sub CommsSettingsToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles CommsSettingsToolStripMenuItem.Click
        'make the comms window visable
        frm_comms_settings.Visible = "true"

        'load combo with ports
        For Each s In System.IO.Ports.SerialPort.GetPortNames()
            frm_comms_settings.Combo_Ports.Items.Add(s)
        Next s

        'recover setting from  settings array
        frm_comms_settings.Combo_Ports.SelectedItem = settings(com_port)
        frm_comms_settings.Combo_Baud_Rate.SelectedItem = settings(baud_rate)
        frm_comms_settings.Combo_Data_Bits.SelectedItem = settings(data_bits)
        frm_comms_settings.Combo_Parity.SelectedItem = settings(parity)
        frm_comms_settings.Combo_Stop_Bits.SelectedItem = settings(stop_bits)
    End Sub
End Class

